#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Feb  7 07:04:49 2021

@author: wor
"""
# working notes towards a single instantiation dict


EXRACTING FROM HERE .....
testInst = CountryDeaths('USA')

covidInstanceDict = {}   # used to  store country instances for plotting etc

def instantiateCountryClass():
    for country in listOfCountryNames:
      instanceString = "covidInstanceDict['"+country+"'] = CountryDeaths('"+country+"')"
      exec(instanceString)                                                  # create the instance


# def graphCountries(listOfCountryNames,graphName, nrFigureCols = 1, directToFile=False):
# def graphCountries(listOfCountryNames,graphName, nrFigureCols = 1, directToFile=False): pass
# def graphCountry(countryName,graphName, nrFigureCols = 1, directToFile=False):
# def graphCountries(listOfCountryNames,graphName, nrFigureCols = 1, directToFile=False): pass
# def graphCountry(countryName,graphName, nrFigureCols = 1, directToFile=False):


                                            # perhaps nicer looking than the matplotlib default
# =================================

for country in listOfCountryNames: 
    instanceString = "covidInstanceDict['"+country+"'] = CountryDeaths('"+country+"')"
    exec(instanceString)                                                        # create the instance
 
    instanceString = "covidInstanceDict['"+countryName+"'] = CountryDeaths('"+countryName+"')"
    exec(instanceString)                  # create the instance

instanceString = "config.covidInstanceDict2['"+countryName+"'] = CountryDeaths('"+countryName+"')"
exec(instanceString)                                                        # create the CountryDeahs() instance




 make this a dictionary!   or a data field in the instantiation - 
 def adjustY (countryName):
    if countryName == 'China':
        return 19                   # China 	[indexes, values]: [131, 303, 294] [38, 56, 278]
    if countryName == 'Argentina':
        return 351                  #Argentina	[indexes, values]: [263, 264, 256] [484, 515, 3351]
    if countryName == 'Bolivia':
        return 165                  #Bolivia	[indexes, values]: [223, 227, 232] [92, 102, 1656]        
    if countryName == 'Ecuador':
        return 500                  #Bolivia	[indexes, values]: [223, 227, 232] [92, 102, 1656]        NB: FIX!
    if countryName == 'India':
        return 1293                 #India	[indexes, values]: [243, 240, 149] [1247, 1290, 2003]
    if countryName == 'Ireland':
        return 22                   #Ireland	[indexes, values]: [100, 92, 96] [57, 77, 220]             NB: FIX!
    if countryName == 'Kyrgyzstan':
        return 100                   #Ireland	[indexes, values]: [100, 92, 96] [57, 77, 220]    
    if countryName == 'Mexico':
        return 1789                 #Mexico	[indexes, values]: [136, 314, 260] [1092, 1217, 2789]
    if countryName == 'Pakistan':
        return 35                   #Pakistan	[indexes, values]: [152, 147, 305] [153, 178, 313]
    if countryName == 'Peru':
        return 143                  #Peru	[indexes, values]: [196, 186, 208] [593, 3887, 4143]
    if countryName == 'Sudan':
        return 27                   #Sudan	[indexes, values]: [131, 303, 294] [38, 56, 278]

def selectColor(value, breakpoints=colorBreakpoints):
    # return a color string based on value breakpoints; 
    indx = 0 
    while True:
        if value <= breakpoints[indx][0]:                                      # the upper limit; include upper limit
            return breakpoints[indx][2]                                        # [2] is the rgb color string #valiue; [1]is the matplotlib colorName
        else:
            indx += 1

# ======================== Barchart  version ==================================

# make this a dictionary!
# ==================== < Handle Anomolies > ===================================
if countryName in config.outlierProvinceList:                               # assigned in covid19class.py
    getMaxs = config.covidInstanceDict2[countryName].maxVals                # where are these generated?
    print ("The Max Values and their indices:", getMaxs)
    oldY = getMaxs[-1][1]
    newY = adjustY(countryName)
#        y= 19 # old Y - 1000
    x = getMaxs[-1][0]                                                      # the index of the max value
    config.covidInstanceDict2[countryName].deathIncrements[x] = newY               # the DB max value to be adjusted
    plt.annotate ('Anomoly adjustment\n was:'+str(oldY)+", now:"+str(newY), xy = (x-1,newY+2), xytext=(x-20,newY+20),   
        arrowprops=dict(facecolor='black', shrink=0.5))                     # arrow to the value adjusted in the chart
#    ================= </ Anomolies > =========================================


selectedColor = selectColor (config.covidInstanceDict2[countryName].max)    # select a color based onthe colorBreakpoints list
#    print ("selectedColor:", selectedColor)
#


def drawBarLegend(breakpoints=colorBreakpoints):
    # sets up the matplotlib legend table to itemize (by default) a color table
    # of max deaths/day - as set in the colorBreakpoints list
    legendColors = []
    legendLabels = []
    colorPatches = []
    SMAshortColor = 'dimgrey'
    
    lowerLimit = 0                                                            # charts not generated for 0 deaths
    for indx in range (len (breakpoints)):
        legendColors += [colorBreakpoints[indx][1]]                         
        legendLabels += [str(lowerLimit+1)+' to ' + str(colorBreakpoints[indx][0])] # the lower limit of this color's range
        lowerLimit = breakpoints[indx][0]
        if indx == len (breakpoints) -1:                                       # kluge to change last label
            legendLabels[-1] = str (breakpoints[-2][0]+1)+' & above'
        

#    maxLabelLen = len(max (legendLabels, key=len))                             # the longest label text
#    print ('maxLabelLen :', maxLabelLen)                                      # attempt to Rjustify text looks horrible, so omit
#    for labelNr in range (len (legendLabels)-1):
#        legendLabels[labelNr] =  ( maxLabelLen - len(legendLabels[labelNr]))*' '+legendLabels[labelNr] #right adjust label hack!


    for indx in range (len (legendLabels)):                                    # make the handles THIS SHOULD BE IN THE CONFIGFILE??
        colorPatches += [mpatches.Patch(color=legendColors[indx], label=legendLabels[indx])]
#    print (colorPatches)
    colorPatches += [mpatches.Patch(color=SMAshortColor, label = '7day Mov.Avge')]  # dim grey for SMA
    return colorPatches

colorPatches = drawBarLegend(colorBreakpoints)                                  # colorPatches r label handles for d legend-generate once!   
config.covidInstanceDict2[countryName].barChartColor = selectedColor        # saved for later use - such as on the webpages                    


def barChartCountry(countryName,graphName, nrFigureCols = 1, directToFile=False):
    # draws a  histogram of a single country instance. 
    # If directToFile=True, closes the plot display after saving an image file
#    title = 'Daily Deaths Reported as Covid-19 Related: '+graphName+u'\U0001F1F2\U0001F1FE'+'\n'+ config.datesList[0][4:]+ " " + config.datesList[0][:4] + '—' +config.datesList[-1][4:]+ " " + config.datesList[-1][:4]
    title = 'Daily Deaths Reported as Covid-19 Related: '+graphName+'\n'+ config.datesList[0][4:]+ " " + config.datesList[0][:4] + '—' +config.datesList[-1][4:]+ " " + config.datesList[-1][:4]
    plt.figure (num = 1, figsize = (18.0,12.0))
 #   plt.annotate('🏴',fontproperties= prop)
    plt.title (title, fontsize=14)
    plt.ylabel("Number of Confirmed Deaths Reported", fontsize=10)
    plt.xlabel("Daily Dates (Sundays labeled)", fontsize=10)
    plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.02)  # was 0.2
    plt.xticks (rotation = 45)                                                  # or 'vertical'
    xlabels = config.datesList #datePad + columnLabels[4:]                                 # The first is Wed Jan 22. dataPad add 3 days to the start
    xmarkers = list (range(0,len(xlabels)+7, 7)) # one per week
    xlabels2 = [xlabels[datey][-6:] for datey in range(0,len(xlabels), 7)]      # omit year- take just month and day
    plt.xticks(xmarkers, xlabels2, fontsize=11)

# ================================ create the region's instance =============== - perhaps should be done en masse following class definition
    instanceString = "config.covidInstanceDict2['"+countryName+"'] = CountryDeaths('"+countryName+"')"
    exec(instanceString)                                                        # create the CountryDeahs() instance
# =============================================================================

# selectedColor = selectColor (config.covidInstanceDict2[countryName].max)             # select a color based onthe colorBreakpoints list
#    dgStr1 = "plt.bar(config.covidInstanceDict2['"
#    dgStr2 = "'].deathIncrements, label='"
#   colorPatches = drawBarLegend(colorBreakpoints)                              # colorPatches are label handles 

# ==================== < Define the legend >===================================
    plt.legend(title='Maximum Daily Deaths', handles=colorPatches, 
                            loc = 'upper left', ncol=1,
                            fancybox=True , shadow = False)                     # wish list: + transparent=True    


#    plt.xlim((0, len (config.covidInstanceDict2[countryName].deathIncrements)+7))      # add a week for enhanced visual spacing 
    xMax = len (config.covidInstanceDict2[countryName].deathIncrements)                # nr of dates
    if ANOMOLY_AJUSTED_COLORS  and countryName in config.outlierProvinceList:
        yMax = config.covidInstanceDict2[countryName].maxVals[-2][1]                   # the second largest # of deaths
    else: 
        yMax = config.covidInstanceDict2[countryName].max                              # max Nr Deaths (controls chart height value)
    # Ajust this value using getMaxs[y[-2][1]]
    plt.xlim((0, xMax +7))                                                      # set 7s-day scale +1 week for enhanced visual spacing 

    worrallStr      = '\nCharts & sonifications: David Worrall (avatar.com.au)'
    urlStr          = '\nProject, homepage: sonification.com.au/covid-19/'
    dataSourceStr   = ''

    props = dict(boxstyle='round', facecolor='cornsilk', alpha=0.5)
    plt.text(xMax/3.0 ,yMax*1.045, urlStr+worrallStr+, fontsize=14,
             verticalalignment='top',  bbox=props)                              # magic number to align it to the top of the chart
    selectedColor = selectColor (config.covidInstanceDict2[countryName].max)    # select a color based onthe colorBreakpoints list
#    print ("selectedColor:", selectedColor)
    config.covidInstanceDict2[countryName].barChartColor = selectedColor        # saved for later use - such as on the webpages                    

#    print ("barChartColor:", config.covidInstanceDict2[countryName].barChartColor)

# prepare to save figure to file
    subDirName = subDirectory (countryName)
    plt.bar(xlabels, config.covidInstanceDict2[countryName].deathIncrements, width=1, align='center', color=selectedColor)    

# ====================add the SMA line chart plots ============================
    config.covidInstanceDict2[countryName].SMAshortPeriod = 7                         # default is 7
    SMAshort = config.covidInstanceDict2[countryName].SMAshortArray
    SMAshort = [np.nan if data <= 0 else data for data in SMAshort ]            # use NaNs to inhibit printing val <= 0
    plt.plot(xlabels,SMAshort, color='dimgrey')  #                     # is adjusted to be same lenas x axis

#    plt.plot(xlabels,config.covidInstanceDict2[countryName].SMAshortArray, color='teal')       # is adjusted so is of same length as x axis - use nans

#    SMAlong =  config.covidInstanceDict2[countryName].SMAlongArray
#    SMAslong = [np.nan if data <= 0 else data for data in SMAshort ]    
#    plt.plot(xlabels,SMAlong, color='saddlebrown') # is adjusted so is of same length as x axis - use nans


# For current testing:
#barChartCountry ('China', 'China', directToFile=True)
#barChartCountry ('Argentina', 'Argentina', directToFile=True)

# comment next line out when you want to run barChartCountry()
#def barChartCountry(countryName,graphName, nrFigureCols = 1, directToFile=False): pass 

#===================  SET UP VARIOUS COUNTRIES GROUPINGS FOR COMPOSITE PLOTTING ==========================
AmericaCentral1     = ['Mexico', 'Brazil', 'Guatemala', 'Bolivia',]

AmericaCentral2     = ['Belize', 'Cuba', 'Honduras',  'Panama', 'Nicaragua']
AmericaNorth        = ['Canada', 'Alberta','British Columbia', 'Diamond Princess', 'Grand Princess', 'Manitoba',
                       'New Brunswick', 'Newfoundland and Labrador', 'Northwest Territories', 'Nova Scotia',
                       'Ontario', 'Prince Edward Island', 'Quebec', 'Saskatchewan', 'US']
AmericaSouth        = ['Venezuela', 'Peru', 'Argentina', 'Uruguay', 'Falkland Islands (Malvinas)', 'French Guiana',
                       'Guyana','Paraguay']

AfricaNorthern1     = ['Senegal' ,'Mauritania', 'Western Sahara', 'Mali', 'Niger', 
                      'Libya','Chad',  'Eritrea','Somalia','Djibouti', 'South Sudan', 'Suriname']
AfricaNorthern2     = ['Egypt', 'Algeria', 'Morocco','Sudan',]
#AfricaCentral       = ['Ghana', 'Burkina Faso', 'Nigeria', 'Ga'zbon', 'Equatorial Guinea', 'Congo',
#                       'Zambia', 'Tanzania', 'Malawi', "Cote dIvoire", 'Togo', 'Benin', 'Burkina Faso']
AfricaCentral1      = ['Ghana',  'Zambia', 'Nigeria','Malawi',]
AfricaCentral2      = ['Burkina Faso', 'Tanzania',  'Togo', 'Benin', 'Burkina Faso', 'Cote dIvoire']  # 'Cote dIvoire', 
AfricaWest          = ['Guinea', 'Guinea-Bissau','Gambia', 'Sierra Leone', 'Liberia',  'Sao Tome and Principe']
AfricaEastern       = ['Mayotte', 'Mauritius',  'Mozambique', 'Rwanda',  'Seychelles', 'Uganda'] #'Eastern Africa',
AfricaSouthern1     = ['Namibia', 'Botswana', 'Angola','Zimbabwe','Madagascar', 'Kenya', 'Lesotho' ]
AfricaSouthern2     = ['South Africa' ]
Asia                = ['China', 'Anhui', 'Beijing', 'Chongqing', 'Fujian', 'Gansu', 'Guangdong', 'Guangxi',
                       'Guizhou', 'Hainan', 'Hebei', 'Heilongjiang', 'Henan', 'Hong Kong', 'Hubei',
                       'Hunan', 'Inner Mongolia', 'Mongolia', 'Jiangsu', 'Jiangxi', 'Jilin', 'Liaoning', 'Macau',
                       'Ningxia', 'Qinghai', 'Shaanxi', 'Shandong', 'Shanghai', 'Shanxi', 'Sichuan',
                       'Tianjin', 'Tibet', 'Xinjiang', 'Yunnan', 'Zhejiang', 'Turks and Caicos Islands',
                       'South Korea', 'Japan','Taiwan', 'Nepal', 'Burma', 'Bhutan', 'Maldives']  # NB no North Korea
AsiaNoChina         = [ 'Turks and Caicos Islands','South Korea', 'Japan','Taiwan', 'Nepal', 'Burma', 'Bhutan', 'Maldives']  # NB no North Korea
AsiaSouth           = ['Bangladesh', 'India','Pakistan', 'Sri Lanka' ]  #  'Myanmar', 
AsiaSouth1          = ['Laos', 'Thailand', 'Vietnam', 'Cambodia', 'Mongolia', 'Tajikistan']
AsiaSouth2          = ['Pakistan', 'India', 'Bangladesh', 'Sri Lanka', 'Laos', 'Thailand', 'Vietnam', 'Cambodia', 'Mongolia', 'Tajikistan' ] #'Myanmar', 
AsiaSouth3          = ['India',]
AsiaSouthEast       = ['Philippines','Malaysia','Singapore','Indonesia', 'Papua New Guinea','Timor-Leste']
Canada1             = ['Alberta', 'Northwest Territories','British Columbia',  'Manitoba', 'New Brunswick', 'Newfoundland and Labrador',
                        'Nova Scotia', 'Prince Edward Island', 'Saskatchewan'] #plus 'Canada' 'Diamond Princess', 'Grand Princess',
Canada2             = ['Ontario', 'Quebec' ] #plus 'Canada' 'Diamond Princess', 'Grand Princess',
Carribean1          = ['Anguilla', 'Antigua and Barbuda', 'Aruba', 'Bahamas', 'Barbados', 'Bermuda',
                        'Cayman Islands', 'Grenada', 'Guadeloupe', 'Haiti',]
Carribean2          = ['Jamaica', 'Martinique', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Pierre and Miquelon',
                        'Saint Vincent and the Grenadines', 'Sint Maarten', 'Trinidad and Tobago', 'Tunisia']
Carribean3          = ['Anguilla', 'Antigua and Barbuda', 'Aruba', 'Bahamas', 'Barbados', 'Bermuda',
                        'Cayman Islands', 'Grenada', 'Guadeloupe', 'Haiti', 'Jamaica', 'Martinique', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Pierre and Miquelon',
                        'Saint Vincent and the Grenadines', 'Sint Maarten', 'Trinidad and Tobago', 'Tunisia']
ChineseProvinces1    = ['Anhui', 'Beijing', 'Chongqing', 'Fujian', 'Gansu', 'Guangdong', 'Guangxi', 'Guizhou']
ChineseProvinces2    = ['Hainan', 'Hebei', 'Heilongjiang', 'Henan', 'Hong Kong', 'Hubei', 'Hunan', 'Inner Mongolia', 'Mongolia']
ChineseProvinces3    = ['Jiangsu', 'Jiangxi', 'Jilin', 'Liaoning', 'Macau', 'Ningxia', 'Qinghai', 'Shaanxi', ]
ChineseProvinces4    = ['Shandong', 'Shanghai', 'Shanxi', 'Sichuan', 'Tianjin', 'Tibet', 'Xinjiang', 'Yunnan', 'Zhejiang']
EuropeNorthEastern   = ['Belarus', 'Estonia', 'Iceland','Kosovo', 'Latvia', 'Lithuania', 'Poland' , 'Russia', 'Kyrgyzstan', 'Slovenia']
EuropeCentralEastern1 = ['Austria', 'Bosnia and Herzegovina', 'Czechia','Hungary', 'Moldova','Romania', 'Serbia', 'Slovakia', 'Ukraine' ]
#EuropeCentralEastern1 = ['Austria', 'Bosnia and Herzegovina', 'Czechia','Hungary', 'Moldova','Romania', 'Serbia', 'Slovakia', 'Ukraine' ]
EuropeNorthWestern1  = [ 'Denmark', 'Finland', 'Iceland', 'Norway', 'Sweden']
EuropeNorthWestern2  = [ 'Denmark', 'Finland', 'Iceland', 'Norway']
EuropeNorthWestern3  = [ 'Sweden']
EuropeSouthEastern   = ['Albania', 'Armenia', 'Azerbaijan', 'Georgia']
EuropeSouthWestern1  = ['Andorra', 'Bulgaria',  'Greece', 'Gibraltar', 'Ireland', 'Isle of Man',
                        'Liechtenstein', 'Luxembourg','Malta', 'Monaco', 'Montenegro',  'Netherlands',
                        'North Macedonia', 'Portugal', 'San Marino',  'Switzerland',  ]
EuropeSouthWestern2 = ['Andorra',  'Greece', 'Gibraltar', 'Ireland', 'Isle of Man',
                        'Liechtenstein', 'Luxembourg','Malta', 'Monaco', 'Montenegro',  'Netherlands',
                        'North Macedonia', 'Portugal', 'San Marino',  'Switzerland',  ]
EuropeSouthWestern3 = [ 'United Kingdom', 'France','Germany', 'Italy', 'Spain', 'Belgium' ]
MiddleEast1         = ['Bahrain', 'Yemen', 'Lebanon', 'Oman', 'Jordan',  'United Arab Emirates']
MiddleEast2         = ['Iran', 'Iraq', 'Saudi Arabia', 'Turkey','Israel', 'Kuwait','Kazakhstan']
MiddleEast3         = ['Qatar',  'Tajikistan', 'Syria', 'Uzbekistan', 'West Bank and Gaza']
Oceania             = ['French Polynesia', 'New Caledonia', 'Australia','Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia',
                       'New Zealand']
AmericaUSA          = ['US']
AustralianStates    = ['Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia']
Australasia         = ['New Zealand', 'Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia']
 
noVictoria          = ['New Zealand', 'Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Western Australia']

#===================  PLOT THE COUNTRY GROUPINGS IN COMPOSITE PLOT ==========================
#Figures now render in the Plots pane by default. 
#To make them also appear inline in the Console, uncheck "Mute Inline Plotting" under the Plots pane options menu. 

# ========  graph the composite charts =========="""  <Used to comment out the multi-graph plots>
graphCountries (AfricaNorthern1,        'Northern Africa 1 of 2',           nrFigureCols = 3, directToFile=True)
graphCountries (AfricaNorthern2,        'Northern Africa 2 of 2',           directToFile=True)
graphCountries (AfricaCentral1,         'Central Africa 1 of 2',           directToFile=True)
graphCountries (AfricaCentral2,         'Central Africa 2 of 2',           directToFile=True)
graphCountries (AfricaWest,             'West Africa',                      directToFile=True)
graphCountries (AfricaEastern,          'Eastern Africa',                   directToFile=True)
graphCountries (AfricaSouthern1,        'Southern Africa (no South Africa)',directToFile=True)
graphCountries (AfricaSouthern2,        'Southern Africa: South Africa',   directToFile=True)

graphCountries (AmericaCentral1,        'Central America 1 of 2 (Brazil & Mexico)', directToFile=True)
graphCountries (AmericaCentral2,        'Central America 2 of 2',           directToFile=True)

graphCountries (AmericaUSA,                    'United States',             directToFile=True)

graphCountries (AsiaNoChina,            'Asia-no China',                    directToFile=True)
graphCountries (AsiaSouth1,             'South Asia 1of2',                  directToFile=True)
graphCountries (AsiaSouth2,             'South Asia 2of2',                  directToFile=True)
graphCountries (AsiaSouth3,             'South Asia 2of2',                  directToFile=True)
graphCountries (AsiaSouthEast,          'South-East Asia',                  directToFile=True)

graphCountries (Australasia,            'Australasian Territories',         directToFile=True)
graphCountries (Canada1,                'Canadian Provinces-no Ontario or Quebec', directToFile=True)
graphCountries (Canada2,                'Canada: Ontario & Quebec',         directToFile=True)

graphCountries (ChineseProvinces1,       'Chinese Provinces 1 of 4',        directToFile=True)
graphCountries (ChineseProvinces2,       'Chinese Provinces 2 of 4',        directToFile=True)
graphCountries (ChineseProvinces3,       'Chinese Provinces 3 of 4',        directToFile=True)
graphCountries (ChineseProvinces4,       'Chinese Provinces 4 of 4',        directToFile=True)

graphCountries (Carribean1,              'Carribean 1 of 3',        nrFigureCols = 2, directToFile=True)
graphCountries (Carribean2,              'Carribean 2 of 3',        nrFigureCols = 2, directToFile=True)
graphCountries (Carribean3,              'Carribean 3 of 3 (All)',  nrFigureCols = 2, directToFile=True)

#graphCountries (EuropeNorthWestern1,     'North-Western Europe',           directToFile=True)
graphCountries (EuropeNorthWestern2,     'North-Western Europe (no Sweden)',directToFile=True)
graphCountries (EuropeNorthWestern3,     'North-Western Europe: Sweden)',   directToFile=True)
graphCountries (EuropeNorthEastern,      'North-Eastern Europe',             directToFile=True)
graphCountries (EuropeCentralEastern1,   'Central-Eastern Europe 1 of 1',   directToFile=True)

graphCountries (EuropeSouthWestern1,     'South-Western Europe 1 of 2', nrFigureCols = 1, directToFile=True)
graphCountries (EuropeSouthWestern2,     'South-Western Europe 2 of 2',     directToFile=True)
graphCountries (EuropeSouthWestern3,     'South-Western Europe 2 of 2',     directToFile=True)
graphCountries (EuropeSouthEastern,      'South-Eastern Europe',             directToFile=True)

graphCountries (MiddleEast1,             'Middle East (1 of 3)',             directToFile=True)
graphCountries (MiddleEast2,             'Middle East (2 of 3)',             directToFile=True)
graphCountries (MiddleEast3,             'Middle East (3 of 3)',             directToFile=True)
#graphCountries (Asia,                   'Asia',                            directToFile=True)
graphCountries (Oceania,                 'Oceania',                          directToFile=True)

#graphCountries (NorthAmerica, 'North America', directToFile=True)
#graphCountries (AustralianStates,       'Australian States',               directToFile=True)

graphCountries (noVictoria,              'Australia (no Victoria)',          directToFile=True)

# ========  END OF   graph the composite charts ==========
#  </Used to comment out the multi-graph plots>"""

# =====================================================================================================
# ====================================  INDIVIDUAL COUNTRY GRAPHINGS ==================================

# a list not for individual plotting (mostly becasue they are v small in number): easily changed!
forfixingList =  ['Argentina', 'Bolivia', 'Chile', 'Ecuador', 'India', 'Ireland', 'Kyrgyzstan', 'Mexico', 'Peru']
sparceList = ['Albania', 'Tunisia','Zambia']

exclusionsList = ['Andorra', 'Angola', 'Anguilla', 'Antigua and Barbuda', 'Aruba', 
                  'Barbadas', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bonaire Sint Eustatius and Saba', 
                  'Botswana', 'British Virgin Islands', 'Brunei', 'Burkina Faso', 'Burundi',
                  'Cabo Verde', 'Cambodia', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 
                  'Chad', 'Comoros', 'Cote dIvoire', 'Cuba', 'Curacao', 'Cyprus', 
                  'Djibouti', 'Dominica', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Eswatini',
                  'Falkland Islands (Malvinas)', 'Faroe Islands', 'Fiji', 'French Guiana', 'French Polynesia', 
                  'Gabon', 'Gibraltar', 'Greenland', 'Grenada', 'Guadeloupe', 'Guinea-Bissau', 
                  'Guinea', 'Guyana', 'Haiti', 'HongKong', 'Iceland', 'Isle of Man', 'Jamaica', 
                  'Laos', 'Latvia', 'Lesotho', 'Liberia', 'Liechtenstein', 'Lithuania', 'Luxembourg', 
                  'Macau', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Martinique',
                  'Mauritania', 'Mauritius', 'Mayotte', 'Monaco', 'Mongolia', 'Montenegro', 'Montserrat', 
                  'Mozambique', 'Namibia', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 
                  'Papua New Guinea', 'Qatar', 'Reunion', 'Rwanda', 'Saint Barthelemy', 
                  'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Pierre and Miquelon', 'San Marino', 
                  'Sao Tome and Principe', 'Senegal', 'Seychelles', 'Sierra Leone', 'Singapore', 
                  'Sint Maarten', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Sudan', 
                  'Sri Lanka', 'Suriname', 'Syria', 'Taiwan', 'Tajikistan', 'Tanzania', 'Thailand', 
                  'Timor-Leste', 'Togo', 'Trinidad and Tobago', 'Turk sand Caicos Islands', 
                  'Uganda', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican', 'Vietnam', 'Western Sahara', 'Zimbabwe']                                          

"""# this tests if the countries in the exclusionList are in the demographicDict.keys(), used below
for country in exclusionsList:
    if country not in demographicDict.keys():
        print (country)
print ("FIN")
"""

# ========  graph major individual countries/regions =====================
#def graphCountry(countryName,graphName, nrFigureCols = 1, directToFile=False):

#    Amalgamate info in the virus data bases with the demographic/population databases: cut to another data module

instantiatedCountryStats = [] 
for country in covidInstanceDict.keys():     #create a list of lists
    instantiatedCountryStats.append([
    covidInstanceDict[country].countryName, 
    covidInstanceDict[country].latitude, 
    covidInstanceDict[country].longitude, 
    covidInstanceDict[country].area, 
    covidInstanceDict[country].population, 
    covidInstanceDict[country].max, 
    covidInstanceDict[country].mean, 
    covidInstanceDict[country].median,  
    covidInstanceDict[country].sortedIndices[-2], 
    covidInstanceDict[country].deathIncrements[covidInstanceDict[country].sortedIndices[-2]], 
    covidInstanceDict[country].sortedIndices[-1], 
    covidInstanceDict[country].deathIncrements[covidInstanceDict[country].sortedIndices[-1]]
    ])

directory =         "/Users/davidworrall/Documents/RESEARCH/COVID-19/dataSets/"
directory =         "/volumes/DRWORANGE32/COVID-19/dataSets/"
imageDirectory =    "/volumes/DRWORANGE32/COVID-19/graphImages/deaths_global/"
fname3 =            "instantiatedCountryStats.csv" # "us-counties20200516.csv"
columnLabels =      ['Country','Latitude','Longitude','Area','Population','MaxNr','Mean','Median','AllButIndx',
                     'AllButVal', 'indxOfBiggest', 'BiggestVal']
#columnLabels = ''.join (columnLabels)
import csv
with open(config.dataDirectory + fname3, '+w', newline='') as myfile:
        writer = csv.writer(myfile, delimiter=',')
        writer.writerow(columnLabels)
        writer.writerows(instantiatedCountryStats)
myfile.close()

""" # dealt with ... (sort of) ... in covid19data.py
if 'Taiwan*' in config.covidInstanceDict2.keys() and 'Taiwan' in config.covidInstanceDict2.keys():
    del config.covidInstanceDict2['Taiwan*]
"""                          
for kee in config.covidInstanceDict2.keys():
    print (kee)
    barChartCountry(kee, kee, nrFigureCols = 1, directToFile=True)


   #  =======  collate statistics from the combined database - for meta-analysis to a .csv file ===============

"""

for kee in  demographicDict.keys():
    first direct from the databases: 
    lat, long, area, population, popden, median_age
    (minval_1>0, addr1), (minval12,addr2), (maxval_2, addr2), totalNrDeaths, density=pop/areaCol

plt.title("Daily Covid-19 Deaths\nfor the period "+columnLabels[4]+ '–' +columnLabels[-1], fontsize=18)
plt.ylabel("Number of Confirmed Deaths", fontsize=12)
plt.legend(title='Country/Region')
plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.25)

#  ------- WORKING ---- UNFINISHED ------------------------------------------
def graphAllProvinces(listOfCountryNames,graphName, nrFigureCols = 1, directToFile=False):
    # draws a single graph of all provinces in the ??? dict (a separate instantiation dictionary). 
    # If directToFile=True, closes the plot display after saving an image file
    title = 'Daily Deaths Reported as Covid-19 Related: '+graphName+'\n'+ config.datesList[0][4:]+ " " + config.datesList[0][:4] + '—' +config.datesList[-1][4:]+ " " + config.datesList[-1][:4]
    plt.figure (num = 1, figsize = (18.0,12.0)) 
    plt.title (title, fontsize=14)
    plt.ylabel("Number of Confirmed Deaths Reported", fontsize=9)
    plt.xlabel("Daily Dates (Sundays labeled)", fontsize=9)
    plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.15)  # was 0.2
    plt.xticks (rotation = 45) #'vertical'
    xlabels = config.datesList #datePad + columnLabels[4:]  # the dates. The first is Wednesday, Jan 22. Need to add 3 days to the beginning
    xmarkers = list (range(0,len(xlabels)+7, 7)) # one per week
    xlabels2 = [xlabels[datey][-6:] for datey in range(0,len(xlabels), 7)]  # omot year- take just month and day
    plt.xticks(xmarkers, xlabels2, fontsize=10)

    for country in listOfCountryNames:
          instanceString = "covidInstanceDict['"+country+"'] = CountryDeaths('"+country+"')"
          exec(instanceString)                  # create the instance
#          print("attempt to execute NANs:", instanceString+'.zeros2NANs()')

          dgStr1 = "plt.plot(covidInstanceDict['"
          dgStr2 = "'].deathIncrements, label='"
          dgStr3 ="', marker='.', linewidth='0.35')"    # switch to line below for point-only graph
          dgStr3 ="', marker='H', linewidth='0.15')"
          #dgStr3 ="', marker='.', linewidth='0.0')"
          dataGraphString = dgStr1 +country+ dgStr2 +country+ dgStr3
          exec(dataGraphString)                         #  store a  created country instance in the country dictionaty

    plt.legend(title='Country/Region', loc = 'upper left', ncol=nrFigureCols, shadow = False)  # wish list + transparent=True
    datey = config.datesList[-1].replace(dateSpacer,"").replace(" ","")    # take out the separator for the filename
    plt.savefig(imageDirectory+graphName+'_covid19_'+datey+'.png', format = 'png',
                orientation='landscape', transparent=False )
    plt.show()
    if directToFile: #  close the Figure #  default is false -- SWITCH TO TRUE TO eact
        plt.close()

def graphCountries(listOfCount ryNames,graphName, nrFigureCols = 1, directToFile=False):
    # draws a single graph of a list of country instances. 
    # If directToFile=True, closes the plot display after saving an image file
    title = 'Daily Deaths Reported as Covid-19 Related: '+graphName+'\n'+ config.datesList[0][4:]+ " " + config.datesList[0][:4] + '—' +config.datesList[-1][4:]+ " " + config.datesList[-1][:4]
    plt.figure (num = 1, figsize = (18.0,12.0)) 
    plt.title (title, fontsize=14)
    plt.ylabel("Number of Confirmed Deaths Reported", fontsize=9)
    plt.xlabel("Daily Dates (Sundays labeled)", fontsize=9)
    plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.15)  # was 0.2
    plt.xticks (rotation = 45) #'vertical'
    xlabels = config.datesList #datePad + columnLabels[4:]  # the dates. The first is Wednesday, Jan 22. Need to add 3 days to the beginning
    xmarkers = list (range(0,len(xlabels)+7, 7)) # one per week
    xlabels2 = [xlabels[datey][-6:] for datey in range(0,len(xlabels), 7)]  # omot year- take just month and day
    plt.xticks(xmarkers, xlabels2, fontsize=10)

    for country in listOfCountryNames:
          instanceString = "covidInstanceDict['"+country+"'] = CountryDeaths('"+country+"')"
          exec(instanceString)                  # create the instance
#          print("attempt to execute NANs:", instanceString+'.zeros2NANs()')

          dgStr1 = "plt.plot(covidInstanceDict['"
          dgStr2 = "'].deathIncrements, label='"
          dgStr3 ="', marker='.', linewidth='0.35')"    # switch to line below for point-only graph
          dgStr3 ="', marker='H', linewidth='0.15')"
          #dgStr3 ="', marker='.', linewidth='0.0')"
          dataGraphString = dgStr1 +country+ dgStr2 +country+ dgStr3
          exec(dataGraphString)                         #  store a  created country instance in the country dictionaty

    plt.legend(title='Country/Region', loc = 'upper left', ncol=nrFigureCols, shadow = False)  # wish list + transparent=True
    datey = config.datesList[-1].replace(dateSpacer,"").replace(" ","")    # take out the separator for the filename
    plt.savefig(imageDirectory+graphName+'_covid19_'+datey+'.png', format = 'png',
                orientation='landscape', transparent=False )
    plt.show()
    if directToFile: #  close the Figure #  default is false -- SWITCH TO TRUE TO eact
        plt.close()

"""


"""
# ====  find the intersections and make  config.demographicDict of the covid regions in the covid-19 data files

# check which countries in the populationDataList are or are not in the config.provinceDeathsDict.keys())
deathProvinceNames = sorted (config.provinceDeathsDict.keys())
inBothDB                    = []                                                # list of regions in covid and demographic data files
inJustDeathDB               = []                                                #list of regions only in covid data files
inJustpopulationDataList    = []                                                #list of regions only in demographic data file - not really needed

for provinceNr in range (2, len (populationDataList)):
#    print (populationDataList[provinceNr][countryNameCol])
    if populationDataList[provinceNr][countryNameCol] in deathProvinceNames:
        inBothDB += [populationDataList[provinceNr][countryNameCol]]
    else:
        inJustDeathDB += [populationDataList[provinceNr][countryNameCol]]

# Now make a demographicDB data for those in inBothDB
for entry in populationDataList:
    if entry[countryNameCol] in inBothDB:
         config.demographicDict[entry[countryNameCol]] = entry                         # take it all easy - could from last index (censusDateCol)                         
                                                                                # was entry[:5] # regionName,countryName,countrySymbol,area,pop
#for region in config.demographicDict.keys():
#    print (config.demographicDict[region][:20])

"""